pipeline{
    agent any
    tools {nodejs "npm"}
    stages{
        stage('Build') {
            steps {
                echo '==== BUILDING STAGE ===='
                nodejs('npm') {
                    sh 'npm install'
                    sh 'npm run build'
                }
            }
        }
        stage('Test') {
            steps {
                echo '==== TESTING STAGE ===='
                nodejs('npm'){
                    echo '==== UNIT TESTS ===='
                    sh 'npm run test:unit'
                }
            }
        }
        stage('Deploy') {
            steps {
                echo '==== DEPLOYING STAGE ===='
                sh 'sudo docker build . -t quickpoll:${BUILD_ID}'
                sh 'sudo docker tag quickpoll:${BUILD_ID} cerberus.ctdesarrollo.org/quickpoll:${BUILD_ID}'
                sh 'sudo docker tag quickpoll:${BUILD_ID} cerberus.ctdesarrollo.org:5000/quickpoll:${BUILD_ID}'
                sh 'sudo docker push cerberus.ctdesarrollo.org:5000/quickpoll:${BUILD_ID}'
                sh 'sudo docker push cerberus.ctdesarrollo.org/quickpoll:${BUILD_ID}'
                sh 'sudo docker-machine ssh managerCerberusDeveloping "docker pull cerberus.ctdesarrollo.org:5000/quickpoll:${BUILD_ID}"'
                sh 'sudo docker-machine ssh managerCerberusDeveloping  "docker service rm quickpoll"||true'
                sh 'sudo docker-machine ssh managerCerberusDeveloping  "docker service create --replicas 3 -p 8081:80 --name quickpoll cerberus.ctdesarrollo.org:5000/quickpoll:${BUILD_ID}"'
            }
        }
    }
}